Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3847)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3848)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id: chemistry_model_mod.f90 3784 2019-03-05 14:16:20Z banzhafs
+! some formatting 
+! 
+! 3784 2019-03-05 14:16:20Z banzhafs
 ! added cs_mech to USE chem_gasphase_mod 
 ! 
@@ -260,12 +263,9 @@
 ! ------------
 !> Chemistry model for PALM-4U
-!> @todo Extend chem_species type by nspec and nvar as addititional elements
+!> @todo Extend chem_species type by nspec and nvar as addititional elements (RF)
+!> @todo Check possibility to reduce dimension of chem_species%conc from nspec to nvar (RF)
 !> @todo Adjust chem_rrd_local to CASE structure of others modules. It is not 
 !>       allowed to use the chemistry model in a precursor run and additionally 
 !>       not using it in a main run
-!> @todo Update/clean-up todo list! (FK)
-!> @todo Add routine chem_check_parameters, add checks for inconsistent or
-!>       unallowed parameter settings. 
-!>       CALL of chem_check_parameters from check_parameters. (FK)
 !> @todo Implement turbulent inflow of chem spcs in inflow_turbulence.
 !> @todo Separate boundary conditions for each chem spcs to be implemented
@@ -277,7 +277,4 @@
 !> @todo test nesting for chem spcs, was implemented by suehring (kanani)
 !> @todo chemistry error messages
-!> @todo Format this module according to PALM coding standard (see e.g. module
-!>       template under http://palm.muk.uni-hannover.de/mosaik/downloads/8 or
-!>       D3_coding_standard.pdf under https://palm.muk.uni-hannover.de/trac/downloads/16)
 ! 
 !------------------------------------------------------------------------------!
@@ -318,31 +315,27 @@
 
     LOGICAL ::  nest_chemistry = .TRUE.  !< flag for nesting mode of chemical species, independent on parent or not
-    !
-    !- Define chemical variables
-    TYPE   species_def
-       CHARACTER(LEN=15)                            ::  name
-       CHARACTER(LEN=15)                            ::  unit
-       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc
-       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_av
-       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_p
-       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  tconc_m
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  cssws_av           
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  flux_s_cs
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  diss_s_cs
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l_cs
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  diss_l_cs
-       REAL(kind=wp), ALLOCATABLE, DIMENSION(:)     ::  conc_pr_init
+!
+!-  Define chemical variables within chem_species
+    TYPE species_def
+       CHARACTER(LEN=15)                            ::  name         !< name of chemical species
+       CHARACTER(LEN=15)                            ::  unit         !< unit (ppm for gases, kg m^-3 for aerosol tracers)
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc         !< concentrations of trace gases
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_av      !< averaged concentrations
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  conc_p       !< conc at prognostic time level
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     ::  tconc_m      !< weighted tendency of conc for previous sub-timestep (Runge-Kutta)
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  cssws_av     !< averaged fluxes of trace gases at surface
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  flux_s_cs    !< 6th-order advective flux at south face of grid box of chemical species (='cs')
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:)   ::  diss_s_cs    !< artificial numerical dissipation flux at south face of grid box of chemical species
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  flux_l_cs    !< 6th-order advective flux at left face of grid box of chemical species (='cs')
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:) ::  diss_l_cs    !< artificial numerical dissipation flux at left face of grid box of chemical species
+       REAL(kind=wp), ALLOCATABLE, DIMENSION(:)     ::  conc_pr_init !< initial profile of chemical species
     END TYPE species_def
-
-
-    TYPE   photols_def                                                            
-       CHARACTER(LEN=15)                            :: name
-       CHARACTER(LEN=15)                            :: unit
-       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     :: freq
+!
+!-- Define photolysis frequencies in phot_frequen
+    TYPE photols_def                                                            
+       CHARACTER(LEN=15)                            :: name          !< name of pgotolysis frequency
+       CHARACTER(LEN=15)                            :: unit          !< unit (1/s)
+       REAL(kind=wp), POINTER, DIMENSION(:,:,:)     :: freq          !< photolysis frequency
     END TYPE photols_def
-
-
-    PUBLIC  species_def
-    PUBLIC  photols_def
 
 
@@ -350,14 +343,22 @@
     TYPE(photols_def), ALLOCATABLE, DIMENSION(:), TARGET, PUBLIC ::  phot_frequen  
 
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_1
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_2
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_3
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_av       
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  freq_1
-
-    INTEGER, DIMENSION(nkppctrl)                           ::  icntrl                            !< Fine tuning kpp
-    REAL(kind=wp), DIMENSION(nkppctrl)                     ::  rcntrl                            !< Fine tuning kpp
-    LOGICAL ::  decycle_chem_lr    = .FALSE.
-    LOGICAL ::  decycle_chem_ns    = .FALSE.
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_1  !< pointer for swapping of timelevels for conc
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_2  !< pointer for swapping of timelevels for conc
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_3  !< pointer for swapping of timelevels for conc
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_av !< averaged concentrations of chemical species       
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  freq_1       !< pointer for phtolysis frequncies 
+                                                                            !< (only 1 timelevel required)
+    INTEGER, DIMENSION(nkppctrl)                           ::  icntrl       !< 20 integer parameters for fine tuning KPP code
+                                                                            !< (e.g. solver type)
+    REAL(kind=wp), DIMENSION(nkppctrl)                     ::  rcntrl       !< 20 real parameters for fine tuning of KPP code
+                                                                            !< (e.g starting internal timestep of solver)
+!
+!-- Decycling of chemistry variables: Dirichlet BCs with cyclic is frequently not
+!-- approproate for chemicals compounds since they may accumulate too much. 
+!-- If no proper boundary conditions from a DYNAMIC input file are available,
+!-- de-cycling applies the initial profiles at the inflow boundaries for 
+!-- Dirichlet boundary conditions
+    LOGICAL ::  decycle_chem_lr    = .FALSE.    !< switch for setting decycling in left-right direction
+    LOGICAL ::  decycle_chem_ns    = .FALSE.    !< switch for setting decycling in south-norht direction
     CHARACTER (LEN=20), DIMENSION(4) ::  decycle_method = &
          (/'dirichlet','dirichlet','dirichlet','dirichlet'/)
@@ -376,12 +377,12 @@
 
 
-    !
-    !-- Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
+!
+!-- Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
     !
     INTEGER(iwp), PARAMETER ::  nlu_dep = 15                   !< Number of DEPAC landuse classes (lu's)
     INTEGER(iwp), PARAMETER ::  ncmp = 10                      !< Number of DEPAC gas components
     INTEGER(iwp), PARAMETER ::  nposp = 69                     !< Number of possible species for deposition
-    !
-    !-- DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
+!
+!-- DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
     INTEGER(iwp) ::  ilu_grass              = 1        
     INTEGER(iwp) ::  ilu_arable             = 2        
@@ -400,18 +401,18 @@
     INTEGER(iwp) ::  ilu_semi_natural_veg   = 15 
 
-    !
-    !-- NH3/SO2 ratio regimes:
+!
+!-- NH3/SO2 ratio regimes:
     INTEGER(iwp), PARAMETER ::  iratns_low      = 1       !< low ratio NH3/SO2
     INTEGER(iwp), PARAMETER ::  iratns_high     = 2       !< high ratio NH3/SO2
     INTEGER(iwp), PARAMETER ::  iratns_very_low = 3       !< very low ratio NH3/SO2
-    !
-    !-- Default:
+!
+!-- Default:
     INTEGER, PARAMETER ::  iratns_default = iratns_low
-    !
-    !-- Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) to W m-2
+!
+!-- Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) to W m-2
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  alpha   =(/ 0.009, 0.009, 0.009, 0.006, 0.006, -999., -999., 0.009, -999.,      &
          -999., 0.009, 0.006, -999., 0.009, 0.008/)*4.57
-    !
-    !-- Set temperatures per land use for f_temp
+!
+!-- Set temperatures per land use for f_temp
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmin = (/ 12.0, 12.0,  12.0,  0.0,  0.0, -999., -999., 12.0, -999., -999.,      &
          12.0,  0.0, -999., 12.0,  8.0/)
@@ -420,16 +421,16 @@
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmax = (/ 40.0, 40.0,  40.0, 36.0, 35.0, -999., -999., 40.0, -999., -999.,      &
          40.0, 35.0, -999., 40.0, 39.0 /)
-    !
-    !-- Set f_min:
+!
+!-- Set f_min:
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  f_min = (/ 0.01, 0.01, 0.01, 0.1, 0.1, -999., -999., 0.01, -999., -999., 0.01,  &
          0.1, -999., 0.01, 0.04/)
 
-    !
-    !-- Set maximal conductance (m/s)
-    !-- (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
+!
+!-- Set maximal conductance (m/s)
+!-- (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  g_max = (/ 270., 300., 300., 140., 150., -999., -999., 270., -999., -999.,      &
-         270., 150., -999., 300., 422./)/41000
-    !
-    !-- Set max, min for vapour pressure deficit vpd
+         270., 150., -999., 300., 422./)/41000.
+!
+!-- Set max, min for vapour pressure deficit vpd
     REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_max = (/1.3, 0.9, 0.9, 0.5, 1.0, -999., -999., 1.3, -999., -999., 1.3,      &
          1.0, -999., 0.9, 2.8/) 
@@ -437,14 +438,14 @@
          3.25, -999., 2.8, 4.5/) 
 
-
     PUBLIC nest_chemistry
-    PUBLIC nspec
     PUBLIC nreact
-    PUBLIC nvar      
-    PUBLIC spc_names
+    PUBLIC nspec               !< number of gas phase chemical species including constant compound (e.g. N2)
+    PUBLIC nvar                !< number of variable gas phase chemical species (nvar <= nspec)
+    PUBLIC photols_def         !< type defining phot_frequen
+    PUBLIC species_def         !< type defining chem_species
+    PUBLIC spc_names           !< names of gas phase chemical species (come from KPP) (come from KPP)
     PUBLIC spec_conc_2  
-
-    !    
-    !-- Interface section
+!    
+!-- Interface section
     INTERFACE chem_3d_data_averaging
        MODULE PROCEDURE chem_3d_data_averaging 
@@ -607,22 +608,18 @@
          chem_statistics, chem_swap_timelevel, chem_wrd_local, chem_depo 
 
-
-
  CONTAINS
 
- !
- !------------------------------------------------------------------------------!
- !
- ! Description:
- ! ------------
- !> Subroutine for averaging 3D data of chemical species. Due to the fact that 
- !> the averaged chem arrays are allocated in chem_init, no if-query concerning
- !> the allocation is required (in any mode). Attention: If you just specify an 
- !> averaged output quantity in the _p3dr file during restarts the first output
- !> includes the time between the beginning of the restart run and the first
- !> output time (not necessarily the whole averaging_interval you have 
- !> specified in your _p3d/_p3dr file )
- !------------------------------------------------------------------------------!
-
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
+!> the averaged chem arrays are allocated in chem_init, no if-query concerning
+!> the allocation is required (in any mode). Attention: If you just specify an 
+!> averaged output quantity in the _p3dr file during restarts the first output
+!> includes the time between the beginning of the restart run and the first
+!> output time (not necessarily the whole averaging_interval you have 
+!> specified in your _p3d/_p3dr file )
+!------------------------------------------------------------------------------!
  SUBROUTINE chem_3d_data_averaging( mode, variable )
 
@@ -638,10 +635,10 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode    !< 
-    CHARACTER (LEN=*) :: variable !< 
-
-    LOGICAL      ::  match_def !< flag indicating natural-type surface
-    LOGICAL      ::  match_lsm !< flag indicating natural-type surface
-    LOGICAL      ::  match_usm !< flag indicating urban-type surface
+    CHARACTER (LEN=*) ::  mode     !< 
+    CHARACTER (LEN=*) ::  variable !< 
+
+    LOGICAL ::  match_def  !< flag indicating default-type surface
+    LOGICAL ::  match_lsm  !< flag indicating natural-type surface
+    LOGICAL ::  match_usm  !< flag indicating urban-type surface
 
     INTEGER(iwp) ::  i                  !< grid index x direction
@@ -649,96 +646,99 @@
     INTEGER(iwp) ::  k                  !< grid index z direction
     INTEGER(iwp) ::  m                  !< running index surface type
-    INTEGER(iwp) :: lsp                 !< running index for chem spcs
+    INTEGER(iwp) ::  lsp               !< running index for chem spcs
 
     IF ( (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_')  )  THEN
 
-    IF ( mode == 'allocate' )  THEN
-       DO lsp = 1, nspec
-          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             chem_species(lsp)%conc_av = 0.0_wp
-          ENDIF
-       ENDDO
-
-    ELSEIF ( mode == 'sum' )  THEN
-
-       DO lsp = 1, nspec
-          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) + &
-                           chem_species(lsp)%conc(k,j,i)
+       IF ( mode == 'allocate' )  THEN
+
+          DO  lsp = 1, nspec
+             IF ( TRIM( variable(1:3) ) == 'kc_' .AND. &
+                  TRIM( variable(4:) ) == TRIM( chem_species(lsp)%name ) )  THEN
+                chem_species(lsp)%conc_av = 0.0_wp
+             ENDIF
+          ENDDO
+
+       ELSEIF ( mode == 'sum' )  THEN
+
+          DO  lsp = 1, nspec
+             IF ( TRIM( variable(1:3) ) == 'kc_' .AND. &
+                  TRIM( variable(4:) ) == TRIM( chem_species(lsp)%name ) )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         chem_species(lsp)%conc_av(k,j,i) =                              &
+                                           chem_species(lsp)%conc_av(k,j,i) +            &
+                                           chem_species(lsp)%conc(k,j,i)
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-          ELSEIF ( TRIM(variable(4:)) == TRIM('cssws*') )        THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   match_def = surf_def_h(0)%start_index(j,i) <=               &
-                        surf_def_h(0)%end_index(j,i)
-                   match_lsm = surf_lsm_h%start_index(j,i) <=                  &
-                        surf_lsm_h%end_index(j,i)
-                   match_usm = surf_usm_h%start_index(j,i) <=                  &
-                        surf_usm_h%end_index(j,i)
-
-                   IF ( match_def )  THEN
-                      m = surf_def_h(0)%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                           chem_species(lsp)%cssws_av(j,i) + &
-                           surf_def_h(0)%cssws(lsp,m)
-                   ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                      m = surf_lsm_h%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                           chem_species(lsp)%cssws_av(j,i) + &
-                           surf_lsm_h%cssws(lsp,m)
-                   ELSEIF ( match_usm )  THEN
-                      m = surf_usm_h%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                           chem_species(lsp)%cssws_av(j,i) + &
-                           surf_usm_h%cssws(lsp,m)
-                   ENDIF
-                ENDDO
-             ENDDO
-          ENDIF
-       ENDDO
-
-    ELSEIF ( mode == 'average' )  THEN
-       DO lsp = 1, nspec
-          IF ( TRIM(variable(1:3)) == 'kc_' .AND. &
-               TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+             ELSEIF ( TRIM( variable(4:) ) == TRIM( 'cssws*' ) )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <=                      &
+                           surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <=                         &
+                           surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <=                         &
+                           surf_usm_h%end_index(j,i)
+
+                      IF ( match_def )  THEN
+                         m = surf_def_h(0)%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                               &
+                              chem_species(lsp)%cssws_av(j,i) + &
+                              surf_def_h(0)%cssws(lsp,m)
+                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
+                         m = surf_lsm_h%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                               &
+                              chem_species(lsp)%cssws_av(j,i) + &
+                              surf_lsm_h%cssws(lsp,m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         chem_species(lsp)%cssws_av(j,i) =                               &
+                              chem_species(lsp)%cssws_av(j,i) + &
+                              surf_usm_h%cssws(lsp,m)
+                      ENDIF
                    ENDDO
                 ENDDO
-             ENDDO
-
-          ELSEIF (TRIM(variable(4:)) == TRIM('cssws*') )            THEN
-             DO i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   chem_species(lsp)%cssws_av(j,i) = chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
+             ENDIF
+          ENDDO
+
+       ELSEIF ( mode == 'average' )  THEN
+
+          DO  lsp = 1, nspec
+             IF ( TRIM( variable(1:3) ) == 'kc_' .AND. &
+                  TRIM( variable(4:) ) == TRIM( chem_species(lsp)%name ) )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         chem_species(lsp)%conc_av(k,j,i) =                              &
+                             chem_species(lsp)%conc_av(k,j,i) /                          &
+                             REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
                 ENDDO
-             ENDDO
-             CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
-          ENDIF
-       ENDDO
+
+             ELSEIF ( TRIM( variable(4:) ) == TRIM( 'cssws*' ) )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      chem_species(lsp)%cssws_av(j,i) =                                  &
+                      chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
+             ENDIF
+          ENDDO
+       ENDIF
 
     ENDIF
 
-    ENDIF
-
  END SUBROUTINE chem_3d_data_averaging
 
-!    
-!------------------------------------------------------------------------------!
-!
+    
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine to initialize and set all boundary conditions for chemical species
 !------------------------------------------------------------------------------!
-
  SUBROUTINE chem_boundary_conds( mode )                                           
 
@@ -755,5 +755,5 @@
         ONLY:  bc_h                                                           
 
-    CHARACTER (len=*), INTENT(IN) ::  mode
+    CHARACTER (LEN=*), INTENT(IN) ::  mode
     INTEGER(iwp) ::  i                            !< grid index x direction.
     INTEGER(iwp) ::  j                            !< grid index y direction.
@@ -768,5 +768,5 @@
        CASE ( 'init' )
 
-          IF ( bc_cs_b == 'dirichlet' )    THEN
+          IF ( bc_cs_b == 'dirichlet' )  THEN
              ibc_cs_b = 0 
           ELSEIF ( bc_cs_b == 'neumann' )  THEN
@@ -774,16 +774,16 @@
           ELSE
              message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'  
-             CALL message( 'chem_boundary_conds', 'CM0429', 1, 2, 0, 6, 0 )     !<
+             CALL message( 'chem_boundary_conds', 'CM0429', 1, 2, 0, 6, 0 )
           ENDIF                                                                  
 !
-!--          Set Integer flags and check for possible erroneous settings for top
-!--          boundary condition. 
-          IF ( bc_cs_t == 'dirichlet' )             THEN
+!--       Set Integer flags and check for possible erroneous settings for top
+!--       boundary condition. 
+          IF ( bc_cs_t == 'dirichlet' )  THEN
              ibc_cs_t = 0 
-          ELSEIF ( bc_cs_t == 'neumann' )           THEN
+          ELSEIF ( bc_cs_t == 'neumann' )  THEN
              ibc_cs_t = 1
           ELSEIF ( bc_cs_t == 'initial_gradient' )  THEN
              ibc_cs_t = 2
-          ELSEIF ( bc_cs_t == 'nested' )            THEN          
+          ELSEIF ( bc_cs_t == 'nested' )  THEN          
              ibc_cs_t = 3
           ELSE
@@ -792,10 +792,11 @@
           ENDIF
 
-
        CASE ( 'set_bc_bottomtop' )                   
+!
 !--          Bottom boundary condtions for chemical species      
-          DO lsp = 1, nspec                                                      
-             IF ( ibc_cs_b == 0 ) THEN                   
-                DO l = 0, 1 
+          DO  lsp = 1, nspec                                                      
+             IF ( ibc_cs_b == 0 )  THEN                   
+                DO  l = 0, 1 
+!
 !--                Set index kb: For upward-facing surfaces (l=0), kb=-1, i.e.
 !--                the chem_species(nspec)%conc_p value at the topography top (k-1)
@@ -805,15 +806,16 @@
                    kb = MERGE( -1, 1, l == 0 )
                    !$OMP PARALLEL DO PRIVATE( i, j, k )
-                   DO m = 1, bc_h(l)%ns
-                      i = bc_h(l)%i(m)            
-                      j = bc_h(l)%j(m)
-                      k = bc_h(l)%k(m)
+                   DO  m = 1, bc_h(l)%ns
+                       i = bc_h(l)%i(m)            
+                       j = bc_h(l)%j(m)
+                       k = bc_h(l)%k(m)
                       chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc(k+kb,j,i) 
                    ENDDO                                        
                 ENDDO                                       
 
-             ELSEIF ( ibc_cs_b == 1 ) THEN
+             ELSEIF ( ibc_cs_b == 1 )  THEN
+!
 !--             in boundary_conds there is som extra loop over m here for passive tracer
-                DO l = 0, 1
+                DO  l = 0, 1
                    kb = MERGE( -1, 1, l == 0 )
                    !$OMP PARALLEL DO PRIVATE( i, j, k )                                           
@@ -828,21 +830,22 @@
              ENDIF
        ENDDO    ! end lsp loop  
-
+!
 !--    Top boundary conditions for chemical species - Should this not be done for all species?
           IF ( ibc_cs_t == 0 )  THEN                    
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc(nzt+1,:,:)        
              ENDDO
           ELSEIF ( ibc_cs_t == 1 )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:)
              ENDDO
           ELSEIF ( ibc_cs_t == 2 )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:) + bc_cs_t_val(lsp) * dzu(nzt+1)
              ENDDO
           ENDIF
-!
+
        CASE ( 'set_bc_lateral' )                       
+!
 !--             Lateral boundary conditions for chem species at inflow boundary
 !--             are automatically set when chem_species concentration is
@@ -854,17 +857,17 @@
 
           IF ( bc_radiation_s )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(:,nys-1,:) = chem_species(lsp)%conc_p(:,nys,:)
              ENDDO
           ELSEIF ( bc_radiation_n )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(:,nyn+1,:) = chem_species(lsp)%conc_p(:,nyn,:)
              ENDDO
           ELSEIF ( bc_radiation_l )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(:,:,nxl-1) = chem_species(lsp)%conc_p(:,:,nxl)
              ENDDO
           ELSEIF ( bc_radiation_r )  THEN
-             DO lsp = 1, nspec
+             DO  lsp = 1, nspec
                 chem_species(lsp)%conc_p(:,:,nxr+1) = chem_species(lsp)%conc_p(:,:,nxr)
              ENDDO
@@ -875,5 +878,5 @@
  END SUBROUTINE chem_boundary_conds
 
-!
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -881,6 +884,12 @@
 !> Boundary conditions for prognostic variables in chemistry: decycling in the 
 !> x-direction
-!-----------------------------------------------------------------------------
+!------------------------------------------------------------------------------!
  SUBROUTINE chem_boundary_conds_decycle( cs_3d, cs_pr_init )
+!
+!-- Decycling of chemistry variables: Dirichlet BCs with cyclic is frequently not
+!-- approproate for chemicals compounds since they may accumulate too much.
+!-- If no proper boundary conditions from a DYNAMIC input file are available,
+!-- de-cycling applies the initial profiles at the inflow boundaries for
+!-- Dirichlet boundary conditions
 
     IMPLICIT NONE 
@@ -897,6 +906,5 @@
 
     flag = 0.0_wp
-
-
+!
 !-- Left and right boundaries
     IF ( decycle_chem_lr  .AND.  bc_lr_cyc )  THEN
@@ -962,6 +970,5 @@
        ENDDO
     ENDIF
-
-
+!
 !-- South and north boundaries
     IF ( decycle_chem_ns  .AND.  bc_ns_cyc )  THEN
@@ -1029,14 +1036,12 @@
     ENDIF
  END SUBROUTINE chem_boundary_conds_decycle
-   !
-!------------------------------------------------------------------------------!
-!
+
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine for checking data output for chemical species
 !------------------------------------------------------------------------------!
-
  SUBROUTINE chem_check_data_output( var, unit, i, ilen, k )
-
 
     IMPLICIT NONE
@@ -1050,5 +1055,5 @@
     INTEGER(iwp) ::  k
 
-    CHARACTER(len=16)    ::  spec_name
+    CHARACTER(LEN=16)    ::  spec_name
 
 !
@@ -1058,16 +1063,16 @@
     unit = 'illegal'
 
-    spec_name = TRIM(var(4:))             !< var 1:3 is 'kc_' or 'em_'.
-
-    IF ( TRIM(var(1:3)) == 'em_' )  THEN
-       DO lsp=1,nspec
-          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+    spec_name = TRIM( var(4:) )             !< var 1:3 is 'kc_' or 'em_'.
+
+    IF ( TRIM( var(1:3) ) == 'em_' )  THEN
+       DO  lsp=1,nspec
+          IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) )  THEN
              unit = 'mol m-2 s-1'
           ENDIF
-          !
-          !-- It is possible to plant PM10 and PM25 into the gasphase chemistry code
-          !-- as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
-          !-- set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
-          IF (spec_name(1:2) == 'PM')   THEN
+!
+!--       It is possible to plant PM10 and PM25 into the gasphase chemistry code
+!--       as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
+!--       set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
+          IF (spec_name(1:2) == 'PM')  THEN
              unit = 'kg m-2 s-1'
           ENDIF
@@ -1076,6 +1081,6 @@
     ELSE
 
-       DO lsp=1,nspec
-          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+       DO  lsp=1,nspec
+          IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) )  THEN
              unit = 'ppm'
           ENDIF
@@ -1084,11 +1089,11 @@
 !--            as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
 !--            set unit to kilograms per m**3 for PM10 and PM25 (PM2.5)
-          IF (spec_name(1:2) == 'PM')   THEN  
+          IF (spec_name(1:2) == 'PM')  THEN  
             unit = 'kg m-3'
           ENDIF
        ENDDO
 
-       DO lsp=1,nphot
-          IF (TRIM(spec_name) == TRIM(phot_frequen(lsp)%name))   THEN
+       DO  lsp=1,nphot
+          IF (TRIM( spec_name ) == TRIM( phot_frequen(lsp)%name ) )  THEN
              unit = 'sec-1'
           ENDIF
@@ -1099,12 +1104,11 @@
     RETURN
  END SUBROUTINE chem_check_data_output
-!
-!------------------------------------------------------------------------------!
-!
+
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Subroutine for checking data output of profiles for chemistry model
 !------------------------------------------------------------------------------!
-
  SUBROUTINE chem_check_data_output_pr( variable, var_count, unit, dopr_unit )
 
